/**
 * Copyright (c) 2021, 2024 Contributors to the Eclipse Foundation
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * generated by Xtext 2.36.0
 */
package org.eclipse.trace4cps.tl.etl;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Throughput Signal</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link org.eclipse.trace4cps.tl.etl.ThroughputSignal#getIdAtt <em>Id Att</em>}</li>
 *   <li>{@link org.eclipse.trace4cps.tl.etl.ThroughputSignal#getAp <em>Ap</em>}</li>
 *   <li>{@link org.eclipse.trace4cps.tl.etl.ThroughputSignal#getScale <em>Scale</em>}</li>
 *   <li>{@link org.eclipse.trace4cps.tl.etl.ThroughputSignal#getConvSpec <em>Conv Spec</em>}</li>
 * </ul>
 *
 * @see org.eclipse.trace4cps.tl.etl.EtlPackage#getThroughputSignal()
 * @model
 * @generated
 */
public interface ThroughputSignal extends Signal
{
  /**
   * Returns the value of the '<em><b>Id Att</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the value of the '<em>Id Att</em>' attribute.
   * @see #setIdAtt(String)
   * @see org.eclipse.trace4cps.tl.etl.EtlPackage#getThroughputSignal_IdAtt()
   * @model
   * @generated
   */
  String getIdAtt();

  /**
   * Sets the value of the '{@link org.eclipse.trace4cps.tl.etl.ThroughputSignal#getIdAtt <em>Id Att</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Id Att</em>' attribute.
   * @see #getIdAtt()
   * @generated
   */
  void setIdAtt(String value);

  /**
   * Returns the value of the '<em><b>Ap</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the value of the '<em>Ap</em>' containment reference.
   * @see #setAp(MtlAp)
   * @see org.eclipse.trace4cps.tl.etl.EtlPackage#getThroughputSignal_Ap()
   * @model containment="true"
   * @generated
   */
  MtlAp getAp();

  /**
   * Sets the value of the '{@link org.eclipse.trace4cps.tl.etl.ThroughputSignal#getAp <em>Ap</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Ap</em>' containment reference.
   * @see #getAp()
   * @generated
   */
  void setAp(MtlAp value);

  /**
   * Returns the value of the '<em><b>Scale</b></em>' attribute.
   * The literals are from the enumeration {@link org.eclipse.trace4cps.tl.etl.TimeUnitEnum}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the value of the '<em>Scale</em>' attribute.
   * @see org.eclipse.trace4cps.tl.etl.TimeUnitEnum
   * @see #setScale(TimeUnitEnum)
   * @see org.eclipse.trace4cps.tl.etl.EtlPackage#getThroughputSignal_Scale()
   * @model
   * @generated
   */
  TimeUnitEnum getScale();

  /**
   * Sets the value of the '{@link org.eclipse.trace4cps.tl.etl.ThroughputSignal#getScale <em>Scale</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Scale</em>' attribute.
   * @see org.eclipse.trace4cps.tl.etl.TimeUnitEnum
   * @see #getScale()
   * @generated
   */
  void setScale(TimeUnitEnum value);

  /**
   * Returns the value of the '<em><b>Conv Spec</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the value of the '<em>Conv Spec</em>' containment reference.
   * @see #setConvSpec(ConvSpec)
   * @see org.eclipse.trace4cps.tl.etl.EtlPackage#getThroughputSignal_ConvSpec()
   * @model containment="true"
   * @generated
   */
  ConvSpec getConvSpec();

  /**
   * Sets the value of the '{@link org.eclipse.trace4cps.tl.etl.ThroughputSignal#getConvSpec <em>Conv Spec</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Conv Spec</em>' containment reference.
   * @see #getConvSpec()
   * @generated
   */
  void setConvSpec(ConvSpec value);

} // ThroughputSignal
