/**
 * Copyright (c) 2021, 2024 Contributors to the Eclipse Foundation
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * generated by Xtext 2.36.0
 */
package org.eclipse.trace4cps.tl.etl.impl;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.MinimalEObjectImpl;

import org.eclipse.trace4cps.tl.etl.ConvSpec;
import org.eclipse.trace4cps.tl.etl.EtlPackage;
import org.eclipse.trace4cps.tl.etl.TimeUnitEnum;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Conv Spec</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link org.eclipse.trace4cps.tl.etl.impl.ConvSpecImpl#getWindowWidth <em>Window Width</em>}</li>
 *   <li>{@link org.eclipse.trace4cps.tl.etl.impl.ConvSpecImpl#getWindowUnit <em>Window Unit</em>}</li>
 * </ul>
 *
 * @generated
 */
public class ConvSpecImpl extends MinimalEObjectImpl.Container implements ConvSpec
{
  /**
   * The default value of the '{@link #getWindowWidth() <em>Window Width</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getWindowWidth()
   * @generated
   * @ordered
   */
  protected static final double WINDOW_WIDTH_EDEFAULT = 0.0;

  /**
   * The cached value of the '{@link #getWindowWidth() <em>Window Width</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getWindowWidth()
   * @generated
   * @ordered
   */
  protected double windowWidth = WINDOW_WIDTH_EDEFAULT;

  /**
   * The default value of the '{@link #getWindowUnit() <em>Window Unit</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getWindowUnit()
   * @generated
   * @ordered
   */
  protected static final TimeUnitEnum WINDOW_UNIT_EDEFAULT = TimeUnitEnum.S;

  /**
   * The cached value of the '{@link #getWindowUnit() <em>Window Unit</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getWindowUnit()
   * @generated
   * @ordered
   */
  protected TimeUnitEnum windowUnit = WINDOW_UNIT_EDEFAULT;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected ConvSpecImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return EtlPackage.Literals.CONV_SPEC;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public double getWindowWidth()
  {
    return windowWidth;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void setWindowWidth(double newWindowWidth)
  {
    double oldWindowWidth = windowWidth;
    windowWidth = newWindowWidth;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, EtlPackage.CONV_SPEC__WINDOW_WIDTH, oldWindowWidth, windowWidth));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public TimeUnitEnum getWindowUnit()
  {
    return windowUnit;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void setWindowUnit(TimeUnitEnum newWindowUnit)
  {
    TimeUnitEnum oldWindowUnit = windowUnit;
    windowUnit = newWindowUnit == null ? WINDOW_UNIT_EDEFAULT : newWindowUnit;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, EtlPackage.CONV_SPEC__WINDOW_UNIT, oldWindowUnit, windowUnit));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case EtlPackage.CONV_SPEC__WINDOW_WIDTH:
        return getWindowWidth();
      case EtlPackage.CONV_SPEC__WINDOW_UNIT:
        return getWindowUnit();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case EtlPackage.CONV_SPEC__WINDOW_WIDTH:
        setWindowWidth((Double)newValue);
        return;
      case EtlPackage.CONV_SPEC__WINDOW_UNIT:
        setWindowUnit((TimeUnitEnum)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case EtlPackage.CONV_SPEC__WINDOW_WIDTH:
        setWindowWidth(WINDOW_WIDTH_EDEFAULT);
        return;
      case EtlPackage.CONV_SPEC__WINDOW_UNIT:
        setWindowUnit(WINDOW_UNIT_EDEFAULT);
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case EtlPackage.CONV_SPEC__WINDOW_WIDTH:
        return windowWidth != WINDOW_WIDTH_EDEFAULT;
      case EtlPackage.CONV_SPEC__WINDOW_UNIT:
        return windowUnit != WINDOW_UNIT_EDEFAULT;
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuilder result = new StringBuilder(super.toString());
    result.append(" (windowWidth: ");
    result.append(windowWidth);
    result.append(", windowUnit: ");
    result.append(windowUnit);
    result.append(')');
    return result.toString();
  }

} //ConvSpecImpl
