/**
 * Copyright (c) 2021, 2024 Contributors to the Eclipse Foundation
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * generated by Xtext 2.36.0
 */
package org.eclipse.trace4cps.tl.etl.impl;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.MinimalEObjectImpl;

import org.eclipse.trace4cps.tl.etl.EtlPackage;
import org.eclipse.trace4cps.tl.etl.Interval;
import org.eclipse.trace4cps.tl.etl.IntervalNN;
import org.eclipse.trace4cps.tl.etl.IntervalNS;
import org.eclipse.trace4cps.tl.etl.IntervalSN;
import org.eclipse.trace4cps.tl.etl.IntervalSS;
import org.eclipse.trace4cps.tl.etl.TimeUnitEnum;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Interval</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link org.eclipse.trace4cps.tl.etl.impl.IntervalImpl#getIss <em>Iss</em>}</li>
 *   <li>{@link org.eclipse.trace4cps.tl.etl.impl.IntervalImpl#getIsn <em>Isn</em>}</li>
 *   <li>{@link org.eclipse.trace4cps.tl.etl.impl.IntervalImpl#getIns <em>Ins</em>}</li>
 *   <li>{@link org.eclipse.trace4cps.tl.etl.impl.IntervalImpl#getInn <em>Inn</em>}</li>
 *   <li>{@link org.eclipse.trace4cps.tl.etl.impl.IntervalImpl#getTimeUnit <em>Time Unit</em>}</li>
 * </ul>
 *
 * @generated
 */
public class IntervalImpl extends MinimalEObjectImpl.Container implements Interval
{
  /**
   * The cached value of the '{@link #getIss() <em>Iss</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getIss()
   * @generated
   * @ordered
   */
  protected IntervalSS iss;

  /**
   * The cached value of the '{@link #getIsn() <em>Isn</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getIsn()
   * @generated
   * @ordered
   */
  protected IntervalSN isn;

  /**
   * The cached value of the '{@link #getIns() <em>Ins</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getIns()
   * @generated
   * @ordered
   */
  protected IntervalNS ins;

  /**
   * The cached value of the '{@link #getInn() <em>Inn</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getInn()
   * @generated
   * @ordered
   */
  protected IntervalNN inn;

  /**
   * The default value of the '{@link #getTimeUnit() <em>Time Unit</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getTimeUnit()
   * @generated
   * @ordered
   */
  protected static final TimeUnitEnum TIME_UNIT_EDEFAULT = TimeUnitEnum.S;

  /**
   * The cached value of the '{@link #getTimeUnit() <em>Time Unit</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getTimeUnit()
   * @generated
   * @ordered
   */
  protected TimeUnitEnum timeUnit = TIME_UNIT_EDEFAULT;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected IntervalImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return EtlPackage.Literals.INTERVAL;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public IntervalSS getIss()
  {
    return iss;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetIss(IntervalSS newIss, NotificationChain msgs)
  {
    IntervalSS oldIss = iss;
    iss = newIss;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, EtlPackage.INTERVAL__ISS, oldIss, newIss);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void setIss(IntervalSS newIss)
  {
    if (newIss != iss)
    {
      NotificationChain msgs = null;
      if (iss != null)
        msgs = ((InternalEObject)iss).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - EtlPackage.INTERVAL__ISS, null, msgs);
      if (newIss != null)
        msgs = ((InternalEObject)newIss).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - EtlPackage.INTERVAL__ISS, null, msgs);
      msgs = basicSetIss(newIss, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, EtlPackage.INTERVAL__ISS, newIss, newIss));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public IntervalSN getIsn()
  {
    return isn;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetIsn(IntervalSN newIsn, NotificationChain msgs)
  {
    IntervalSN oldIsn = isn;
    isn = newIsn;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, EtlPackage.INTERVAL__ISN, oldIsn, newIsn);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void setIsn(IntervalSN newIsn)
  {
    if (newIsn != isn)
    {
      NotificationChain msgs = null;
      if (isn != null)
        msgs = ((InternalEObject)isn).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - EtlPackage.INTERVAL__ISN, null, msgs);
      if (newIsn != null)
        msgs = ((InternalEObject)newIsn).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - EtlPackage.INTERVAL__ISN, null, msgs);
      msgs = basicSetIsn(newIsn, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, EtlPackage.INTERVAL__ISN, newIsn, newIsn));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public IntervalNS getIns()
  {
    return ins;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetIns(IntervalNS newIns, NotificationChain msgs)
  {
    IntervalNS oldIns = ins;
    ins = newIns;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, EtlPackage.INTERVAL__INS, oldIns, newIns);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void setIns(IntervalNS newIns)
  {
    if (newIns != ins)
    {
      NotificationChain msgs = null;
      if (ins != null)
        msgs = ((InternalEObject)ins).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - EtlPackage.INTERVAL__INS, null, msgs);
      if (newIns != null)
        msgs = ((InternalEObject)newIns).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - EtlPackage.INTERVAL__INS, null, msgs);
      msgs = basicSetIns(newIns, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, EtlPackage.INTERVAL__INS, newIns, newIns));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public IntervalNN getInn()
  {
    return inn;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetInn(IntervalNN newInn, NotificationChain msgs)
  {
    IntervalNN oldInn = inn;
    inn = newInn;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, EtlPackage.INTERVAL__INN, oldInn, newInn);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void setInn(IntervalNN newInn)
  {
    if (newInn != inn)
    {
      NotificationChain msgs = null;
      if (inn != null)
        msgs = ((InternalEObject)inn).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - EtlPackage.INTERVAL__INN, null, msgs);
      if (newInn != null)
        msgs = ((InternalEObject)newInn).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - EtlPackage.INTERVAL__INN, null, msgs);
      msgs = basicSetInn(newInn, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, EtlPackage.INTERVAL__INN, newInn, newInn));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public TimeUnitEnum getTimeUnit()
  {
    return timeUnit;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void setTimeUnit(TimeUnitEnum newTimeUnit)
  {
    TimeUnitEnum oldTimeUnit = timeUnit;
    timeUnit = newTimeUnit == null ? TIME_UNIT_EDEFAULT : newTimeUnit;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, EtlPackage.INTERVAL__TIME_UNIT, oldTimeUnit, timeUnit));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case EtlPackage.INTERVAL__ISS:
        return basicSetIss(null, msgs);
      case EtlPackage.INTERVAL__ISN:
        return basicSetIsn(null, msgs);
      case EtlPackage.INTERVAL__INS:
        return basicSetIns(null, msgs);
      case EtlPackage.INTERVAL__INN:
        return basicSetInn(null, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case EtlPackage.INTERVAL__ISS:
        return getIss();
      case EtlPackage.INTERVAL__ISN:
        return getIsn();
      case EtlPackage.INTERVAL__INS:
        return getIns();
      case EtlPackage.INTERVAL__INN:
        return getInn();
      case EtlPackage.INTERVAL__TIME_UNIT:
        return getTimeUnit();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case EtlPackage.INTERVAL__ISS:
        setIss((IntervalSS)newValue);
        return;
      case EtlPackage.INTERVAL__ISN:
        setIsn((IntervalSN)newValue);
        return;
      case EtlPackage.INTERVAL__INS:
        setIns((IntervalNS)newValue);
        return;
      case EtlPackage.INTERVAL__INN:
        setInn((IntervalNN)newValue);
        return;
      case EtlPackage.INTERVAL__TIME_UNIT:
        setTimeUnit((TimeUnitEnum)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case EtlPackage.INTERVAL__ISS:
        setIss((IntervalSS)null);
        return;
      case EtlPackage.INTERVAL__ISN:
        setIsn((IntervalSN)null);
        return;
      case EtlPackage.INTERVAL__INS:
        setIns((IntervalNS)null);
        return;
      case EtlPackage.INTERVAL__INN:
        setInn((IntervalNN)null);
        return;
      case EtlPackage.INTERVAL__TIME_UNIT:
        setTimeUnit(TIME_UNIT_EDEFAULT);
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case EtlPackage.INTERVAL__ISS:
        return iss != null;
      case EtlPackage.INTERVAL__ISN:
        return isn != null;
      case EtlPackage.INTERVAL__INS:
        return ins != null;
      case EtlPackage.INTERVAL__INN:
        return inn != null;
      case EtlPackage.INTERVAL__TIME_UNIT:
        return timeUnit != TIME_UNIT_EDEFAULT;
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuilder result = new StringBuilder(super.toString());
    result.append(" (timeUnit: ");
    result.append(timeUnit);
    result.append(')');
    return result.toString();
  }

} //IntervalImpl
