/**
 * Copyright (c) 2021, 2024 Contributors to the Eclipse Foundation
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * generated by Xtext 2.36.0
 */
package org.eclipse.trace4cps.tl.etl.impl;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.trace4cps.tl.etl.ConvSpec;
import org.eclipse.trace4cps.tl.etl.EtlPackage;
import org.eclipse.trace4cps.tl.etl.WipSignal;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Wip Signal</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link org.eclipse.trace4cps.tl.etl.impl.WipSignalImpl#getIdAtt <em>Id Att</em>}</li>
 *   <li>{@link org.eclipse.trace4cps.tl.etl.impl.WipSignalImpl#getConvSpec <em>Conv Spec</em>}</li>
 * </ul>
 *
 * @generated
 */
public class WipSignalImpl extends SignalImpl implements WipSignal
{
  /**
   * The default value of the '{@link #getIdAtt() <em>Id Att</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getIdAtt()
   * @generated
   * @ordered
   */
  protected static final String ID_ATT_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getIdAtt() <em>Id Att</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getIdAtt()
   * @generated
   * @ordered
   */
  protected String idAtt = ID_ATT_EDEFAULT;

  /**
   * The cached value of the '{@link #getConvSpec() <em>Conv Spec</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getConvSpec()
   * @generated
   * @ordered
   */
  protected ConvSpec convSpec;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected WipSignalImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return EtlPackage.Literals.WIP_SIGNAL;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String getIdAtt()
  {
    return idAtt;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void setIdAtt(String newIdAtt)
  {
    String oldIdAtt = idAtt;
    idAtt = newIdAtt;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, EtlPackage.WIP_SIGNAL__ID_ATT, oldIdAtt, idAtt));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public ConvSpec getConvSpec()
  {
    return convSpec;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetConvSpec(ConvSpec newConvSpec, NotificationChain msgs)
  {
    ConvSpec oldConvSpec = convSpec;
    convSpec = newConvSpec;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, EtlPackage.WIP_SIGNAL__CONV_SPEC, oldConvSpec, newConvSpec);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void setConvSpec(ConvSpec newConvSpec)
  {
    if (newConvSpec != convSpec)
    {
      NotificationChain msgs = null;
      if (convSpec != null)
        msgs = ((InternalEObject)convSpec).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - EtlPackage.WIP_SIGNAL__CONV_SPEC, null, msgs);
      if (newConvSpec != null)
        msgs = ((InternalEObject)newConvSpec).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - EtlPackage.WIP_SIGNAL__CONV_SPEC, null, msgs);
      msgs = basicSetConvSpec(newConvSpec, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, EtlPackage.WIP_SIGNAL__CONV_SPEC, newConvSpec, newConvSpec));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case EtlPackage.WIP_SIGNAL__CONV_SPEC:
        return basicSetConvSpec(null, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case EtlPackage.WIP_SIGNAL__ID_ATT:
        return getIdAtt();
      case EtlPackage.WIP_SIGNAL__CONV_SPEC:
        return getConvSpec();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case EtlPackage.WIP_SIGNAL__ID_ATT:
        setIdAtt((String)newValue);
        return;
      case EtlPackage.WIP_SIGNAL__CONV_SPEC:
        setConvSpec((ConvSpec)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case EtlPackage.WIP_SIGNAL__ID_ATT:
        setIdAtt(ID_ATT_EDEFAULT);
        return;
      case EtlPackage.WIP_SIGNAL__CONV_SPEC:
        setConvSpec((ConvSpec)null);
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case EtlPackage.WIP_SIGNAL__ID_ATT:
        return ID_ATT_EDEFAULT == null ? idAtt != null : !ID_ATT_EDEFAULT.equals(idAtt);
      case EtlPackage.WIP_SIGNAL__CONV_SPEC:
        return convSpec != null;
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuilder result = new StringBuilder(super.toString());
    result.append(" (idAtt: ");
    result.append(idAtt);
    result.append(')');
    return result.toString();
  }

} //WipSignalImpl
